---
title: HTMLScriptElement
slug: Web/API/HTMLScriptElement
tags:
  - API
  - HTML DOM
  - Interface
  - NeedsNewLayout
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">HTML {{HTMLElement("script")}} elements expose the <strong><code>HTMLScriptElement</code></strong> interface, which provides special properties and methods for manipulating the behavior and execution of <code>&lt;script&gt;</code> elements (beyond the inherited {{domxref("HTMLElement")}} interface).</span></p>

<p>JavaScript files should be served with the <code>application/javascript</code> <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME type</a>, but browsers are lenient and block them only if the script is served with an image type (<code>image/*</code>), video type (<code>video/*</code>), audio type (<code>audio/*</code>), or <code>text/csv</code>. If the script is blocked, its element receives an {{event("error")}} event; otherwise, it receives a {{event("load")}} event.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLScriptElement.type")}}</dt>
 <dd>Is a {{domxref("DOMString")}} representing the MIME type of the script. It reflects the {{htmlattrxref("type","script")}} attribute.</dd>

 <dt>{{domxref("HTMLScriptElement.src")}}</dt>
 <dd>Is a {{domxref("DOMString")}} representing the URL of an external script. It reflects the {{htmlattrxref("src","script")}} attribute.</dd>

 <dt>{{domxref("HTMLScriptElement.event")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}}; an obsolete way of registering event handlers on elements in an HTML document.</dd>

 <dt>{{domxref("HTMLScriptElement.charset")}}</dt>
 <dd>Is a {{domxref("DOMString")}} representing the character encoding of an external script. It reflects the {{htmlattrxref("charset","script")}} attribute.</dd>

 <dt>{{domxref("HTMLScriptElement.async")}}</dt>
 <dt>{{domxref("HTMLScriptElement.defer")}}</dt>
 <dd>
  <p>The <code>async</code> and <code>defer</code> attributes are {{domxref("Boolean")}} attributes that control how the script should be executed. <strong>The <code>defer</code> and <code>async</code> attributes must not be specified if the <code>src</code> attribute is absent.</strong></p>

  <p>There are three possible execution modes:</p>

  <ol>
   <li>If the <code>async</code> attribute is present, then the script will be executed asynchronously as soon as it downloads.</li>
   <li>If the <code>async</code> attribute is absent but the <code>defer</code> attribute is present, then the script is executed when <a href="/en-US/docs/Web/Events/DOMContentLoaded">the page has finished parsing</a>.</li>
   <li>If neither attribute is present, then the script is fetched and executed immediately, blocking further parsing of the page.</li>
  </ol>

  <p>The <code>defer</code> attribute may be specified with the <code>async</code> attribute, so legacy browsers that only support <code>defer</code> (and not <code>async</code>) fall back to the <code>defer</code> behavior instead of the default blocking behavior.</p>

  <div class="note"><strong>Note:</strong> The exact processing details for these attributes are complex, involving many different aspects of HTML, and therefore are scattered throughout the specification. <a href="http://www.w3.org/html/wg/drafts/html/master/scripting-1.html#prepare-a-script">These algorithms</a> describe the core ideas, but they rely on the parsing rules for {{HTMLElement("script")}} <a href="http://www.w3.org/html/wg/drafts/html/master/syntax.html#scriptTag">start</a> and <a href="http://www.w3.org/html/wg/drafts/html/master/syntax.html#scriptEndTag">end</a> tags in HTML, <a href="http://www.w3.org/html/wg/drafts/html/master/syntax.html#scriptForeignEndTag">in foreign content</a>, and <a href="http://www.w3.org/html/wg/drafts/html/master/the-xhtml-syntax.html#scriptTagXML">in XML</a>; the rules for the <a href="/en-US/docs/DOM/document.write"><code>document.write()</code></a> method; the handling of <a href="http://www.w3.org/html/wg/drafts/html/master/webappapis.html#scripting">scripting</a>; and so on.</div></dd>

 <dt>{{domxref("HTMLScriptElement.crossOrigin")}} {{experimental_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} reflecting the <a href="/en-US/docs/Web/HTML/CORS_settings_attributes">CORS setting</a> for the script element. For scripts from other <a href="/en-US/docs/Glossary/Origin">origins</a>, this controls if error information will be exposed.</dd>

 <dt>{{domxref("HTMLScriptElement.text")}}</dt>
 <dd>
  <p>Is a {{domxref("DOMString")}} that joins and returns the contents of all <a href="/en-US/docs/DOM/Text"><code>Text</code> nodes</a> inside the {{HTMLElement("script")}} element (ignoring other nodes like comments) in tree order. On setting, it acts the same way as the <a href="/en-US/docs/DOM/Node.textContent"><code>textContent</code></a> IDL attribute.</p>

  <div class="note"><strong>Note:</strong> When inserted using the <a href="/en-US/docs/DOM/document.write"><code>document.write()</code></a> method, {{HTMLElement("script")}} elements execute (typically synchronously), but when inserted using <a href="/en-US/docs/DOM/element.innerHTML"><code>innerHTML</code></a> or <a href="/en-US/docs/DOM/element.outerHTML"><code>outerHTML</code></a>, they do not execute at all.</div>
 </dd>

 <dt>{{domxref("HTMLScriptElement.noModule")}}</dt>
 <dd>Is a {{domxref("Boolean")}} that if true, stops the script's execution in browsers that support <a href="https://hacks.mozilla.org/2015/08/es6-in-depth-modules/">ES2015 modules</a> — used to run fallback scripts in older browsers that do <em>not</em> support JavaScript modules.</dd>

 <dt>{{domxref("HTMLScriptElement.referrerPolicy")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("referrerPolicy", "script")}} HTML attribute indicating which referrer to use when fetching the script, and fetches done by that script.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>No specific methods; inherits methods from its parent, {{domxref("HTMLElement")}}.</em></p>

<h2 id="Examples">Examples</h2>

<h3 id="Dynamically_importing_scripts">Dynamically importing scripts</h3>

<p>Let's create a function that imports new scripts within a document creating a {{HTMLElement("script")}} node <em>immediately before</em> the {{HTMLElement("script")}} that hosts the following code (through {{domxref("document.currentScript")}}). These scripts will be <strong>asynchronously</strong> executed. For more details, see the <a href="#defer_property"><code>defer</code></a> and <a href="#async_property"><code>async</code></a> properties.</p>

<pre class="brush: js">function loadError(oError) {
  throw new URIError("The script " + oError.target.src + " didn't load correctly.");
}

function prefixScript(url, onloadFunction) {
  var newScript = document.createElement("script");
  newScript.onerror = loadError;
  if (onloadFunction) { newScript.onload = onloadFunction; }
  document.currentScript.parentNode.insertBefore(newScript, document.currentScript);
  newScript.src = url;
}</pre>

<p>This next function, instead of prepending the new scripts immediately before the {{domxref("document.currentScript")}} element, appends them as children of the {{HTMLElement("head")}} tag.</p>

<pre class="brush: js">function loadError(oError) {
  throw new URIError("The script " + oError.target.src + " didn't load correctly.");
}

function affixScriptToHead(url, onloadFunction) {
  var newScript = document.createElement("script");
  newScript.onerror = loadError;
  if (onloadFunction) { newScript.onload = onloadFunction; }
  document.head.appendChild(newScript);
  newScript.src = url;
}
</pre>

<p>Sample usage:</p>

<pre class="brush: js">affixScriptToHead("myScript1.js");
affixScriptToHead("myScript2.js", function () { alert("The script \"myScript2.js\" has been correctly loaded."); });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmlscriptelement", "HTMLScriptElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', "scripting-1.html#the-script-element", "HTMLScriptElement")}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "scripting-1.html#the-script-element", "HTMLScriptElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>The following properties are now obsolete: <code>htmlFor,</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-81598695', 'HTMLScriptElement')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>No change from {{SpecName("DOM1")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-81598695', 'HTMLScriptElement')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLScriptElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>HTML {{HTMLElement("script")}} element</li>
 <li>HTML {{HTMLElement("noscript")}} element</li>
 <li>{{domxref("document.currentScript")}}</li>
 <li><a href="/en-US/docs/DOM/Using_web_workers">Web Workers</a> (code snippets similar to scripts but executed in <a href="/en-US/docs/JavaScript/DedicatedWorkerGlobalScope">another global context</a>)</li>
 <li><a href="http://pieisgood.org/test/script-link-events/">Ryan Grove's &lt;script&gt; and &lt;link&gt; node event compatibility chart</a></li>
</ul>
